LootDropConfig								= ZO_Object:Subclass()
LootDropConfig.db							= nil
LootDropConfig.EVENT_TOGGLE_XP				= 'LOOTDROP_TOGGLE_XP'
LootDropConfig.EVENT_TOGGLE_SKILL_XP		= 'LOOTDROP_TOGGLE_SKILL_XP'
LootDropConfig.EVENT_TOGGLE_COIN			= 'LOOTDROP_TOGGLE_COIN'
LootDropConfig.EVENT_TOGGLE_LOOT			= 'LOOTDROP_TOGGLE_LOOT'
LootDropConfig.EVENT_TOGGLE_MAIL_LOOT		= 'LOOTDROP_TOGGLE_MAIL_LOOT'
LootDropConfig.EVENT_TOGGLE_AP				= 'LOOTDROP_TOGGLE_AP'
LootDropConfig.EVENT_TOGGLE_BT				= 'LOOTDROP_TOGGLE_BT'
LootDropConfig.EVENT_TOGGLE_JUNK			= 'LOOTDROP_TOGGLE_JUNK'
LootDropConfig.EVENT_TOGGLE_DEBUGLOG		= 'LOOTDROP_TOGGLE_DEBUGLOG'
LootDropConfig.EVENT_TOGGLE_STYLE			= 'LOOTDROP_TOGGLE_STYLE'
LootDropConfig.EVENT_TOGGLE_LOCK			= 'LOOTDROP_TOGGLE_LOCK'
LootDropConfig.EVENT_TOGGLE_RARITY			= 'LOOTDROP_TOGGLE_RARITY'
LootDropConfig.EVENT_TOGGLE_MOVEUP			= 'LOOTDROP_TOGGLE_MOVEUP'
LootDropConfig.EVENT_CHANGE_DIMENSIONS		= 'LOOTDROP_CHANGE_DIMENSIONS'

--Global constants -------------------------------------------------------------
LootDrop_sDefRushmik="|cD3B830Rushmik|r"
LootDrop_sDefPawkette="|cFF66CCPawkette|r"
LootDrop_sDefDefault="Default"

LootDrop_sListBoxNo = "No"
LootDrop_sListBoxStacked = "Stacked"
LootDrop_sListBoxNotStacked = "Not Stacked"
LootDrop_sListBoxStandard = "Standard"
LootDrop_sListBoxExtended = "Extended"
--Local constants -------------------------------------------------------------
local ADDON_VERSION = "2.1"
local ADDON_NAME = "LootDrop"
--Libraries--------------------------------------------------------------------
local CBM = CALLBACK_MANAGER
local LAM2 = LibStub("LibAddonMenu-2.0")
if ( not LAM2 ) then return end
-------------------------------------------------------------------------------
function LootDropConfig:New( ... )
	local result = ZO_Object.New( self )
	result:Initialize( ... )
	return result
end
-------------------------------------------------------------------------------
function LootDropConfig:Initialize( db )
	self.db = db
	
	local panelData = {
			type = "panel",
			name = ADDON_NAME,
			displayName = ADDON_NAME .. " continued by |cAA0000Flagrick|r",
			author = "|cFF66CCPawkette|r",
			version = ADDON_VERSION,
			slashCommand = "/lootdrop",
			registerForRefresh = true,
			registerForDefaults = true,
		}

	LAM2:RegisterAddonPanel(ADDON_NAME, panelData)

	local optionsTable = {
		------------GENERAL--------------
		{
			type = "header",
			name = "General",
			width = "full",	--or "half" (optional)
		},
		{
			type = "dropdown",
			name = "Experience",
			tooltip = "Should we show experience gains ?",
			choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStandard, LootDrop_sListBoxExtended},
			getFunc = function() self:ManageCompatibility_Xp() return self.db.experience end,
			setFunc = function(valueString) self:ToggleXP(valueString) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.experience
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "dropdown",
			name = "Gold",
			tooltip = "Should we show gold gain and loss ?",
			choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStandard, LootDrop_sListBoxExtended},
			getFunc = function() self:ManageCompatibility_Money() return self.db.coin end,
			setFunc = function(valueString) self:ToggleCoin(valueString) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.coin
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "dropdown",
			name = "Alliance Points",
			tooltip = "Should we show Alliance Points ?",
			choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked},
			getFunc = function() self:ManageCompatibility_AP() return self.db.alliance end,
			setFunc = function(valueString) self:ToggleAP(valueString) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.alliance
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "Battle Tokens",
			tooltip = "Should we show Battle Tokens ?",
			getFunc = function() return self.db.battle end,
			setFunc = function(value) self:ToggleBT(value) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.battle
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "Loot",
			tooltip = "Should we show loot ?",
			getFunc = function() return self.db.loot end,
			setFunc = function(value) self:ToggleLoot(value) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.loot
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "- Mail Loot",
			tooltip = "Should we show mail loot ?",
			getFunc = function() return self.db.mailloot end,
			setFunc = function(value) self:ToggleMailLoot(value) end,
			width = "full",	--or "half" (optional)
			disabled = function() return not self.db.loot end,
			default = LootDrop_Defaults.mailloot
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "- Name Loot",
			tooltip = "Should we show name of loot ?",
			getFunc = function() return self.db.nameloot end,
			setFunc = function(value) self:ToggleNameLoot(value) end,
			width = "full",	--or "half" (optional)
			disabled = function() return not self.db.loot end,
			default = LootDrop_Defaults.nameloot
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "- Inventory stack Loot",
			tooltip = "Should we show inventory stack of loot ?",
			getFunc = function() return self.db.stackloot end,
			setFunc = function(value) self:ToggleStackLoot(value) end,
			width = "full",	--or "half" (optional)
			disabled = function() return not self.db.loot end,
			default = LootDrop_Defaults.stackloot
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "- Style Loot",
			tooltip = "Should we show style of loot ?",
			getFunc = function() return self.db.styleloot end,
			setFunc = function(value) self:ToggleStyleLoot(value) end,
			width = "full",	--or "half" (optional)
			disabled = function() return not self.db.loot end,
			default = LootDrop_Defaults.styleloot
			--warning = "Will need to reload the UI.",	--(optional)
			},
			{
			type = "checkbox",
			name = "Junk",
			tooltip = "Should we send trash items as junk in inventory bag ?",
			getFunc = function() return self.db.Junk end,
			setFunc = function(value) self:ToggleJunk(value) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.Junk
			--warning = "Will need to reload the UI.",	--(optional)
			},
		------------SKILLS--------------
		{
			type = "header",
			name = "Skills",
			width = "full",	--or "half" (optional)
		},
		{
			type = "dropdown",
			name = "Craft Xp",
			tooltip = "Should we show Craft Xp ?",
			choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked},
			getFunc = function() self:ManageCompatibility_Craft() return self.db.SkillXp end,
			setFunc = function(value) self:ToggleSkillXp(value) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.SkillXp
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "dropdown",
			name = "Guild reputation",
			tooltip = "Should we show Guild reputation Xp?",
			choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked},
			getFunc = function() return self.db.Guilds end,
			setFunc = function(value) self:ToggleGuildXp(value) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.Guilds
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "dropdown",
			name = "Fence Xp",
			tooltip = "Should we show Fence Xp?",
			choices = {LootDrop_sListBoxNo, LootDrop_sListBoxStacked, LootDrop_sListBoxNotStacked},
			getFunc = function() return self.db.Fence end,
			setFunc = function(value) self:ToggleFenceXp(value) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.Fence
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "dropdown",
			name = "Book knowledge",
			tooltip = "Should we show Book knowledge Xp ?",
			choices = {LootDrop_sListBoxNo, LootDrop_sListBoxNotStacked},
			getFunc = function() return self.db.Books end,
			setFunc = function(value) self:ToggleBookXp(value) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.Books
			--warning = "Will need to reload the UI.",	--(optional)
			},
		------------DIM & STYLE--------------
		{
			type = "header",
			name = "Dimensions and style",
			width = "full",	--or "half" (optional)
		},
		{
			type = "slider",
			name = "Display Duration",
			tooltip = "How long should we show droppables for ?",
			min = 1,
			max = 30,
			step = 1,	--(optional)
			getFunc = function() return self.db.displayduration end,
			setFunc = function(value) self.db.displayduration = value end,
			width = "half",	--or "half" (optional)
			default = LootDrop_Defaults.displayduration
			--default = 5,	--(optional)
		},
		{
			type = "slider",
			name = "Width",
			tooltip = "Entry Width.",
			min = 100,
			max = 300,
			step = 1,	--(optional)
			getFunc = function() return self.db.width end,
			setFunc = function(value) self:ChangeWidth(value) end,
			width = "half",	--or "half" (optional)
			default = LootDrop_Defaults.width
			--default = 5,	--(optional)
		},
		{
			type = "slider",
			name = "Height",
			tooltip = "Entry Height.",
			min = 25,
			max = 100,
			step = 1,	--(optional)
			getFunc = function() return self.db.height end,
			setFunc = function(value) self:ChangeHeight(value) end,
			width = "half",	--or "half" (optional)
			default = LootDrop_Defaults.height
			--default = 5,	--(optional)
		},
		{
			type = "slider",
			name = "Padding",
			tooltip = "Padding between entries.",
			min = 0,
			max = 25,
			step = 1,	--(optional)
			getFunc = function() return self.db.padding end,
			setFunc = function(value) self:ChangePadding(value) end,
			width = "half",	--or "half" (optional)
			default = LootDrop_Defaults.padding
			--default = 5,	--(optional)
		},
		{
			type = "checkbox",
			name = "Stack Up",
			tooltip = "If checked, the loots will be stack up at bottom right position of Lootdrop frame, otherwise stack down at top left position of Lootdrop frame.",
			getFunc = function() return self.db.MoveUp end,
			setFunc = function(value) self:ToggleMoveUp(value) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.MoveUp
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "Rarity border view",
			tooltip = "If not checked, LootDrop will not show item rarity.",
			getFunc = function() return self.db.rarity end,
			setFunc = function(value) self:ToggleRarity(value) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.rarity
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "dropdown",
			name = "Style",
			tooltip = "Pick a style.",
			choices = {LootDrop_sDefDefault, LootDrop_sDefPawkette, LootDrop_sDefRushmik},
			getFunc = function() return self.db.sListStyle end,
			setFunc = function(valueString) self:PickStyle(valueString) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.sListStyle
			--warning = "Will need to reload the UI.",	--(optional)
		},
		{
			type = "slider",
			name = "Font Size",
			tooltip = "Label font size.",
			min = 10,
			max = 22,
			step = 1,	--(optional)
			getFunc = function() return self.db.FontSize end,
			setFunc = function(value) self:ChangeFontSize(value) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.FontSize
			--default = 5,	--(optional)
		},
		------------DEBUG--------------
		{
			type = "header",
			name = "Debug options",
			width = "full",	--or "half" (optional)
		},
		{
			type = "checkbox",
			name = "Debug Log",
			tooltip = "Should we send debug Loot log in chat box ?",
			getFunc = function() return self.db.DbgLog end,
			setFunc = function(value) self:ToggleDbgLog(value) end,
			width = "full",	--or "half" (optional)
			default = LootDrop_Defaults.DbgLog
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "Debug Log time",
			tooltip = "Should we display time with debug log ?",
			getFunc = function() return self.db.DbgLogTime end,
			setFunc = function(value) self:ToggleDbgLogTime(value) end,
			width = "full",	--or "half" (optional)
			disabled = function() return not self.db.DbgLog end,
			default = LootDrop_Defaults.DbgLogTime
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "Debug Log item style",
			tooltip = "Should we display item style with debug log ?",
			getFunc = function() return self.db.DbgLogItemStyle end,
			setFunc = function(value) self:ToggleDbgLogItemStyle(value) end,
			width = "full",	--or "half" (optional)
			disabled = function() return not self.db.DbgLog end,
			default = LootDrop_Defaults.DbgLogItemStyle
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "Debug Log Xp, Ap, Bt and Skill",
			tooltip = "Should we display Xp, Ap, Bt and Skill with debug log ? (Xp, Ap, Bt and Skills have to be checked in LootDrop General & Skills settings)",
			getFunc = function() return self.db.DbgLogXp end,
			setFunc = function(value) self:ToggleDbgLogXp(value) end,
			width = "full",	--or "half" (optional)
			disabled = function() return not self.db.DbgLog end,
			default = LootDrop_Defaults.DbgLogXp
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "Debug Log Gold",
			tooltip = "Should we display gold with debug log ? (Gold have to be checked in LootDrop general settings)",
			getFunc = function() return self.db.DbgLogGold end,
			setFunc = function(value) self:ToggleDbgLogGold(value) end,
			width = "full",	--or "half" (optional)
			disabled = function() return not self.db.DbgLog end,
			default = LootDrop_Defaults.DbgLogGold
			--warning = "Will need to reload the UI.",	--(optional)
			},
		{
			type = "checkbox",
			name = "Debug Log Tag",
			tooltip = "Should we display tag with debug log ?",
			getFunc = function() return self.db.DbgLogTag end,
			setFunc = function(value) self:ToggleDbgLogTag(value) end,
			width = "full",	--or "half" (optional)
			disabled = function() return not self.db.DbgLog end,
			default = LootDrop_Defaults.DbgLogTag
			--warning = "Will need to reload the UI.",	--(optional)
			},
		------------LOCK/UNLOCK--------------
		{
			type = "header",
			name = "Lock/Unlock Frame",
			width = "full",	--or "half" (optional)
		},
		{
			type = "description",
			--title = "My Title",	--(optional)
			title = nil,	--(optional)
			text = "Unlock the LootDrop main frame makes it darker, and allows you to move it freely. When locked, it becomes transparent.",
			width = "full",	--or "half" (optional)
		},
		{
			type = "button",
			name = "Lock/Unlock",
			tooltip = "Click to move the LootDrop Frame, or to lock it.",
			func = function() self:ToggleLock() end,
			width = "half",	--or "half" (optional)
			--warning = "Will need to reload the UI.",	--(optional)
		},
	}

	LAM2:RegisterOptionControls(ADDON_NAME, optionsTable)

end

-------------------------------------------------------------------------------
function LootDropConfig:ManageCompatibility_Craft()
	if (self.db.SkillXp == false ) then
		self.db.SkillXp = LootDrop_sListBoxNo
	elseif (self.db.SkillXp == true ) then
		self.db.SkillXp = LootDrop_sListBoxNotStacked
	end
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleSkillXp(value)
	self.db.SkillXp = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL_XP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleGuildXp(value)
	self.db.Guilds = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL_XP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleFenceXp(value)
	self.db.Fence = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL_XP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleBookXp(value)
	self.db.Books = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_SKILL_XP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLog(value)
	self.db.DbgLog = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogTime(value)
	self.db.DbgLogTime = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogItemStyle(value)
	self.db.DbgLogItemStyle = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogXp(value)
	self.db.DbgLogXp = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogGold(value)
	self.db.DbgLogGold = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleDbgLogTag(value)
	self.db.DbgLogTag = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_DEBUGLOG )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleJunk(value)
	self.db.Junk = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_JUNK )
end
-------------------------------------------------------------------------------
function LootDropConfig:ChangeWidth(width)
	self.db.width = width
	CBM:FireCallbacks( self.EVENT_CHANGE_DIMENSIONS )
end
-------------------------------------------------------------------------------
function LootDropConfig:ChangeHeight(height)
	self.db.height = height
	CBM:FireCallbacks( self.EVENT_CHANGE_DIMENSIONS )
end
-------------------------------------------------------------------------------
function LootDropConfig:ChangePadding(padding)
	self.db.padding = padding
	CBM:FireCallbacks( self.EVENT_CHANGE_DIMENSIONS )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleMoveUp(value) 
	self.db.MoveUp = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_MOVEUP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleRarity(value) 
	self.db.rarity = value
	CBM:FireCallbacks( self.EVENT_TOGGLE_RARITY )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleLock() 
	self.db.lootdrop_lock = not self.db.lootdrop_lock
	CBM:FireCallbacks( self.EVENT_TOGGLE_LOCK )
end
-------------------------------------------------------------------------------
function LootDropConfig:PickStyle(sValue)
   self.db.sListStyle = sValue
   CBM:FireCallbacks( self.EVENT_TOGGLE_STYLE )
end
-------------------------------------------------------------------------------
function LootDropConfig:ChangeFontSize(sValue)
   self.db.FontSize = sValue
   CBM:FireCallbacks( self.EVENT_TOGGLE_STYLE )
end
-------------------------------------------------------------------------------
function LootDropConfig:ManageCompatibility_Xp()
    if (self.db.experience == false ) then
        self.db.experience = LootDrop_sListBoxNo
    elseif (self.db.experience == true ) then
        self.db.experience = LootDrop_sListBoxExtended
    end
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleXP(valueString)
    self.db.experience = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_XP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ManageCompatibility_Money()
    if (self.db.coin == false ) then
        self.db.coin = LootDrop_sListBoxNo
    elseif (self.db.coin == true ) then
        self.db.coin = LootDrop_sListBoxExtended
    end
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleCoin(valueString)
    self.db.coin = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_COIN )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleLoot(value)
    self.db.loot = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_LOOT )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleMailLoot(value)
    self.db.mailloot = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_MAIL_LOOT )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleNameLoot(value)
    self.db.nameloot = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_LOOT )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleStackLoot(value)
    self.db.stackloot = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_LOOT )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleStyleLoot(value)
    self.db.styleloot = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_LOOT )
end
-------------------------------------------------------------------------------
function LootDropConfig:ManageCompatibility_AP()
    if (self.db.alliance == false ) then
        self.db.alliance = LootDrop_sListBoxNo
    elseif (self.db.alliance == true ) then
        self.db.alliance = LootDrop_sListBoxStacked
    end
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleAP(valueString)
    self.db.alliance = valueString
    CBM:FireCallbacks( self.EVENT_TOGGLE_AP )
end
-------------------------------------------------------------------------------
function LootDropConfig:ToggleBT(value)
    self.db.battle = value
    CBM:FireCallbacks( self.EVENT_TOGGLE_BT )
end
-------------------------------------------------------------------------------